/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.payroll.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.common.dao.MKihonDao;
import jp.mosp.kintai.payroll.dto.KdSubstituteHolidayDto;

/**
 * KD_SUBSTITUTE_HOLIDAY(代替休暇管理テーブル)のDAOクラス 。
 */
public class KdSubstituteHolidayDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * KD_SUBSTITUTE_HOLIDAY(代替休暇管理テーブル)。
	 */
	public static final String	TABLE							= "KD_SUBSTITUTE_HOLIDAY";
	
	/**
	 * KEY_1 = SUBSTITUTE_ID(管理ID)。
	 */
	public static final String	KEY_1							= "SUBSTITUTE_ID";
	
	// 列名
	/**
	 * SUBSTITUTE_ID(管理ID)。
	 */
	public static final String	COL_SUBSTITUTE_ID				= "SUBSTITUTE_ID";
	/**
	 * K_CODE(社員コード)。
	 */
	public static final String	COL_K_CODE						= "K_CODE";
	/**
	 * OCCUR_YEAR(発生年)。
	 */
	public static final String	COL_OCCUR_YEAR					= "OCCUR_YEAR";
	/**
	 * OCCUR_MONTH(発生月)。
	 */
	public static final String	COL_OCCUR_MONTH					= "OCCUR_MONTH";
	/**
	 * CLOSE_DATE(締切日)。
	 */
	public static final String	COL_CLOSE_DATE					= "CLOSE_DATE";
	/**
	 * LIMIT_START_DATE(期限開始日)。
	 */
	public static final String	COL_LIMIT_START_DATE			= "LIMIT_START_DATE";
	/**
	 * LIMIT_END_DATE(期限終了日)。
	 */
	public static final String	COL_LIMIT_END_DATE				= "LIMIT_END_DATE";
	/**
	 * ATTITUDE_STATUS(意向状況)。
	 */
	public static final String	COL_ATTITUDE_STATUS				= "ATTITUDE_STATUS";
	/**
	 * PAYMENT_ACQUIRE_TIME(代替休暇取得時間外)。
	 */
	public static final String	COL_PAYMENT_ACQUIRE_TIME		= "PAYMENT_ACQUIRE_TIME";
	/**
	 * PAYMENT_ACQUIRE_HOLIDAY(代替休暇取得休日時間外)。
	 */
	public static final String	COL_PAYMENT_ACQUIRE_HOLIDAY		= "PAYMENT_ACQUIRE_HOLIDAY";
	/**
	 * PAYMENT_QUIT_TIME(代替休暇放棄時間外)。
	 */
	public static final String	COL_PAYMENT_QUIT_TIME			= "PAYMENT_QUIT_TIME";
	/**
	 * USE_HOLIDAY_TIME(利用時間)。
	 */
	public static final String	COL_USE_HOLIDAY_TIME			= "USE_HOLIDAY_TIME";
	/**
	 * ACQUISITION_STATUS(取得状況)。
	 */
	public static final String	COL_ACQUISITION_STATUS			= "ACQUISITION_STATUS";
	/**
	 * LIQUIDATION_OVER_TIME(代休決済による時間外清算時間)。
	 */
	public static final String	COL_LIQUIDATION_OVER_TIME		= "LIQUIDATION_OVER_TIME";
	/**
	 * LIQUIDATION_WEEK_HOLIDAY(代休決済による休日時間外清算時間)。
	 */
	public static final String	COL_LIQUIDATION_WEEK_HOLIDAY	= "LIQUIDATION_WEEK_HOLIDAY";
	/**
	 * DECISION_STATUS(決済状況)。
	 */
	public static final String	COL_DECISION_STATUS				= "DECISION_STATUS";
	/**
	 * DELETE_FLAG(削除フラグ)。
	 */
	public static final String	COL_DELETE_FLAG					= "DELETE_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public KdSubstituteHolidayDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<KdSubstituteHolidayDto> mappingAll() throws SQLException {
		List<KdSubstituteHolidayDto> all = new ArrayList<KdSubstituteHolidayDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return KD_SUBSTITUTE_HOLIDAYレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private KdSubstituteHolidayDto mapping() throws SQLException {
		KdSubstituteHolidayDto dto = new KdSubstituteHolidayDto();
		dto.setSubstituteId(rs.getLong(COL_SUBSTITUTE_ID));
		dto.setKCode(rs.getString(COL_K_CODE));
		dto.setOccurYear(rs.getInt(COL_OCCUR_YEAR));
		dto.setOccurMonth(rs.getInt(COL_OCCUR_MONTH));
		dto.setCloseDate(rs.getDate(COL_CLOSE_DATE));
		dto.setLimitStartDate(rs.getDate(COL_LIMIT_START_DATE));
		dto.setLimitEndDate(rs.getDate(COL_LIMIT_END_DATE));
		dto.setAttitudeStatus(rs.getString(COL_ATTITUDE_STATUS));
		dto.setPaymentAcquireTime(rs.getInt(COL_PAYMENT_ACQUIRE_TIME));
		dto.setPaymentAcquireHoliday(rs.getInt(COL_PAYMENT_ACQUIRE_HOLIDAY));
		dto.setPaymentQuitTime(rs.getInt(COL_PAYMENT_QUIT_TIME));
		dto.setUseHolidayTime(rs.getInt(COL_USE_HOLIDAY_TIME));
		dto.setAcquisitionStatus(rs.getString(COL_ACQUISITION_STATUS));
		dto.setLiquidationOverTime(rs.getInt(COL_LIQUIDATION_OVER_TIME));
		dto.setLiquidationWeekHoliday(rs.getInt(COL_LIQUIDATION_WEEK_HOLIDAY));
		dto.setDecisionStatus(rs.getString(COL_DECISION_STATUS));
		dto.setDeleteFlag(rs.getInt(COL_DELETE_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得。
	 * @param substituteId 管理ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdSubstituteHolidayDto findForKey(long substituteId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, substituteId);
			executeQuery();
			KdSubstituteHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得。
	 * @param substituteId 管理ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdSubstituteHolidayDto findForUpdate(long substituteId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, substituteId);
			executeQuery();
			KdSubstituteHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param substituteId 管理ID
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForCondition(long substituteId) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_SUBSTITUTE_ID);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, substituteId);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param occurYear 発生年
	 * @param occurMonth 発生月
	 * @param decisionStatus 決済状況
	 * @param date 年月日
	 * @return 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForCondition(int occurYear, int occurMonth, String decisionStatus, Date date)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_OCCUR_YEAR);
			sb.append(" = ? AND ");
			sb.append(COL_OCCUR_MONTH);
			sb.append(" = ? AND ");
			sb.append(COL_DECISION_STATUS);
			sb.append(" = ? AND ");
			sb.append(COL_CLOSE_DATE);
			sb.append(" < ?");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, occurYear);
			setParam(index++, occurMonth);
			setParam(index++, decisionStatus);
			setParam(index++, date);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param limitEndDate 期限終了日
	 * @param decisionStatus 決済状況
	 * @return 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForCondition(Date limitEndDate, String decisionStatus) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_LIMIT_END_DATE);
			sb.append(" < ? AND ");
			sb.append(COL_DECISION_STATUS);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, limitEndDate);
			setParam(index++, decisionStatus);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param startDate 期間開始日
	 * @param endDate 期間終了日
	 * @param decisionStatus 決済状況
	 * @return 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForCondition(Date startDate, Date endDate, String decisionStatus)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_LIMIT_END_DATE);
			sb.append(" >= ? ");
			sb.append("AND ");
			sb.append(COL_LIMIT_END_DATE);
			sb.append(" <= ?");
			sb.append("AND ");
			sb.append(COL_DECISION_STATUS);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, startDate);
			setParam(index++, endDate);
			setParam(index++, decisionStatus);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param occurYear 発生年
	 * @param occurMonth 発生月
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public KdSubstituteHolidayDto findForOccurMonth(String kCode, int occurYear, int occurMonth) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ? AND ");
			sb.append(COL_OCCUR_YEAR);
			sb.append(" = ? AND ");
			sb.append(COL_OCCUR_MONTH);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			setParam(index++, occurYear);
			setParam(index++, occurMonth);
			executeQuery();
			KdSubstituteHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param occurYear 発生年
	 * @param occurMonth 発生月
	 * @param acquisitionStatus 取得状況
	 * @param decisionStatus 決済状況
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public KdSubstituteHolidayDto findForOccurMonth(String kCode, int occurYear, int occurMonth,
			String acquisitionStatus, String decisionStatus) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ? AND ");
			sb.append(COL_OCCUR_YEAR);
			sb.append(" = ? AND ");
			sb.append(COL_OCCUR_MONTH);
			sb.append(" = ? AND ");
			sb.append(COL_ACQUISITION_STATUS);
			sb.append(" = ? AND ");
			sb.append(COL_DECISION_STATUS);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			setParam(index++, occurYear);
			setParam(index++, occurMonth);
			setParam(index++, acquisitionStatus);
			setParam(index++, decisionStatus);
			executeQuery();
			KdSubstituteHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param occurYear 発生年
	 * @param occurMonth 発生月
	 * @param acquisition 取得状況
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForOccurMonth(int occurYear, int occurMonth, String acquisition)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_OCCUR_YEAR);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_OCCUR_MONTH);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_ACQUISITION_STATUS);
			sb.append(" = ?");
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, occurYear);
			setParam(index++, occurMonth);
			setParam(index++, acquisition);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param closeDate 年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public KdSubstituteHolidayDto findForCloseDate(String kCode, Date closeDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ? AND ");
			sb.append(COL_CLOSE_DATE);
			sb.append(" >= ? ");
			sb.append(getOrderBy());
			sb.append(COL_CLOSE_DATE);
			sb.append(" ");
			sb.append(getDesc());
			sb.append(getLimit());
			sb.append("1");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			setParam(index++, closeDate);
			executeQuery();
			KdSubstituteHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param targetDate 対象年月日
	 * @param acquisition 取得状況
	 * @param decision 決済状況
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForTargetDate(String kCode, Date targetDate, String acquisition,
			String decision) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ?");
			if (acquisition.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_ACQUISITION_STATUS);
				sb.append(" = ?");
			}
			if (decision.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_DECISION_STATUS);
				sb.append(" = ?");
			}
			sb.append(" AND ");
			sb.append(COL_LIMIT_START_DATE);
			sb.append(" <= ? ");
			sb.append(" AND ");
			sb.append(COL_LIMIT_END_DATE);
			sb.append(" >= ? ");
			sb.append(getOrderBy());
			sb.append(COL_OCCUR_YEAR);
			sb.append(",");
			sb.append(COL_OCCUR_MONTH);
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			if (acquisition.length() != 0) {
				setParam(index++, acquisition);
			}
			if (decision.length() != 0) {
				setParam(index++, decision);
			}
			setParam(index++, targetDate);
			setParam(index++, targetDate);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param kName 社員名
	 * @param occurYear 発生年
	 * @param occurMonth 発生月
	 * @param attitude 意向状況
	 * @param acquisition 取得状況
	 * @param decision 決済状況
	 * @return 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<KdSubstituteHolidayDto> findForTargetDate(String kCode, String kName, String occurYear,
			String occurMonth, String attitude, String acquisition, String decision) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			/* 社員コード設定 */
			sb.append(COL_K_CODE + " LIKE ? ");
			/* 社員名設定 */
			sb.append(" AND ");
			sb.append(" ( ");
			sb.append(COL_K_CODE + " IN (" + MKihonDao.getSearchKNameSubQuery() + ") ");
			sb.append(" ) ");
			/* 発生年設定 */
			if (occurYear.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_OCCUR_YEAR);
				sb.append(" = ?");
			}
			/* 発生月設定 */
			if (occurMonth.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_OCCUR_MONTH);
				sb.append(" = ?");
			}
			/* 意向状況設定 */
			if (attitude.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_ATTITUDE_STATUS);
				sb.append(" = ?");
			}
			/* 取得状況設定 */
			if (acquisition.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_ACQUISITION_STATUS);
				sb.append(" = ?");
			}
			/* 決済状況設定 */
			if (decision.length() != 0) {
				sb.append(" AND ");
				sb.append(COL_DECISION_STATUS);
				sb.append(" = ?");
			}
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode + "%");
			setParam(index++, "%" + kName + "%");
			if (occurYear.length() != 0) {
				setParam(index++, Integer.parseInt(occurYear));
			}
			if (occurMonth.length() != 0) {
				setParam(index++, Integer.parseInt(occurMonth));
			}
			if (attitude.length() != 0) {
				setParam(index++, attitude);
			}
			if (acquisition.length() != 0) {
				setParam(index++, acquisition);
			}
			if (decision.length() != 0) {
				setParam(index++, decision);
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * max値取得
	 * @return String 最大連番
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public String findForMax() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			String max = "";
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT MAX(");
			sb.append(COL_SUBSTITUTE_ID);
			sb.append(") FROM ");
			sb.append(TABLE);
			prepareStatement(sb.toString());
			executeQuery();
			if (rs.next()) {
				max = String.valueOf(rs.getLong(1));
			}
			return max;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入。
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(KdSubstituteHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新。
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(KdSubstituteHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getSubstituteId());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除。
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(KdSubstituteHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getSubstituteId());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private void setParams(KdSubstituteHolidayDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getSubstituteId());
		setParam(index++, dto.getKCode());
		setParam(index++, dto.getOccurYear());
		setParam(index++, dto.getOccurMonth());
		setParam(index++, dto.getCloseDate());
		setParam(index++, dto.getLimitStartDate());
		setParam(index++, dto.getLimitEndDate());
		setParam(index++, dto.getAttitudeStatus());
		setParam(index++, dto.getPaymentAcquireTime());
		setParam(index++, dto.getPaymentAcquireHoliday());
		setParam(index++, dto.getPaymentQuitTime());
		setParam(index++, dto.getUseHolidayTime());
		setParam(index++, dto.getAcquisitionStatus());
		setParam(index++, dto.getLiquidationOverTime());
		setParam(index++, dto.getLiquidationWeekHoliday());
		setParam(index++, dto.getDecisionStatus());
		setParam(index++, dto.getDeleteFlag());
		setCommonParams(isInsert);
	}
	
}
